#import "Controller.h"
#import "NSString_Lines.h"
#import "NSArray_Ranges.h"
  
@implementation Controller

- (void) applicationDidFinishLaunching: (NSNotification *) notification
{
  [[line window] makeFirstResponder: line];
}

- (void)selectLine:(id)sender
{
  unsigned int lineNumber = [line intValue];
  NSString *textString = [text string];
  NSRange selectedRange;

  if(lineNumber < 0){
    [self displayError];
  }

  selectedRange = [textString rangeOfLine: lineNumber];

  if(selectedRange.location == NSNotFound){
    [self displayError];
  }else{
    [text setTextColor: nil];
    [text setTextColor: [NSColor blueColor] range: selectedRange];
    [text scrollRangeToVisible: selectedRange];
    [text setNeedsDisplay: YES];
    [location setIntValue: selectedRange.location];
    [length setIntValue: selectedRange.length];
  }

  [[line window] makeFirstResponder: line];
}

- (void) textViewDidChangeSelection: (NSNotification *) notification
{
  NSRange selectedRange = [text selectedRange];
  NSArray *ranges = [[text string] arrayOfLineRangesInRange: selectedRange];

  [selectionField setStringValue: NSStringFromRange(selectedRange)];
  [rangeDisplayText setString: [ranges rangeArrayDescription]];
}

- (void) displayError
{
  NSBeep();
  [location setStringValue: @"N/A"];
  [length setStringValue: @"N/A"];
}

@end

